SystemOrganization addCategory: #CopyHierarchy!

!ClassDescription methodsFor: '*CopyHierarchy' stamp: 'hjo 4/20/2012 10:18'!
definitionWithSuperclass
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition and: [self traitComposition notEmpty]) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy methodsFor: '2' stamp: 'hjo 4/20/2012 11:33'!
changeSuperclassAfterDupClass: aClass

	|dup|
	dup := self dupClass: aClass.
	dup superclass name = (self nameOfDupOfClass: aClass superclass) ifTrue: [^self].
	self moveClassNamed: dup name toSuper: (self nameOfDupOfClass: aClass superclass).! !

!CopyHierarchy methodsFor: '1' stamp: 'hjo 4/20/2012 11:51'!
classCategoryForDupedClass: aString 

	classCategoryForDupedClass := aString! !

!CopyHierarchy methodsFor: '1' stamp: 'hjo 4/20/2012 11:31'!
classExistsByName: aSymbol

	^[Smalltalk at: aSymbol. true] on: KeyNotFound do: [:exp| false ].! !

!CopyHierarchy methodsFor: '1' stamp: 'hjo 4/20/2012 11:51'!
classNamePrefix: aString 

	classNamePrefix := aString ! !

!CopyHierarchy methodsFor: '2' stamp: 'hjo 4/20/2012 11:30'!
dupClass: aClass

	| dupName dup |
	dupName := self nameOfDupOfClass: aClass.
	(self classExistsByName: dupName) ifTrue: [ ^Smalltalk at: dupName ].
	dup := aClass duplicateClassWithNewName: dupName.
	dup category: classCategoryForDupedClass.
	^dup
	

	 ! !

!CopyHierarchy methodsFor: '2' stamp: 'hjo 4/20/2012 10:26'!
moveClassNamed: classSymbol toSuper: superClassSymbol

	Compiler evaluate: (superClassSymbol ,  (Smalltalk at: classSymbol) definitionWithSuperclass).! !

!CopyHierarchy methodsFor: '1' stamp: 'hjo 4/20/2012 10:52'!
nameOfDupOfClass: aClass

	^(classNamePrefix, aClass name) asSymbol! !

!CopyHierarchy methodsFor: '4' stamp: 'hjo 4/20/2012 11:52'!
removeCategoryOfDupes

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !

!CopyHierarchy methodsFor: '4' stamp: 'hjo 4/20/2012 11:47'!
runCollection
	classNamePrefix := 'X'.
	classCategoryForDupedClass := 'NewCol'.
	self runWithAllKindOf: Collection.! !

!CopyHierarchy methodsFor: '4' stamp: 'hjo 4/20/2012 11:36'!
runGraidentFillStyle
	classNamePrefix := 'TK'.
	classCategoryForDupedClass := 'Talon'.
	self runWithClass: GradientFillStyle.! !

!CopyHierarchy methodsFor: '4' stamp: 'hjo 4/20/2012 11:36'!
runLineSegment
	classNamePrefix := 'Daliot'.
	classCategoryForDupedClass := 'DuppyDup'.
	self runWithClass: LineSegment.! !

!CopyHierarchy methodsFor: '3' stamp: 'hjo 4/20/2012 12:10'!
runWithAllKindOf: aClass

	self dupClass: aClass.
	aClass allSubclassesDo: [:each| self changeSuperclassAfterDupClass: each ].! !

!CopyHierarchy methodsFor: '3' stamp: 'hjo 4/20/2012 11:38'!
runWithClass: aClass

	self dupClass: aClass.
	aClass subclasses do: [ :each | self changeSuperclassAfterDupClass: each ].! !
